unit MainWindow;

//////////////////////////////////////////////////////////////
//Signsoft VisIt: Transparency                              //
//////////////////////////////////////////////////////////////
//This program demonstrates how different transparency      //
//settings affect the rendering and how alpha values and    //
//colors influence the result.                              //
//////////////////////////////////////////////////////////////

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  VisObj, VisShape, VisMat, VisTex, VisLight, VisAttr, VisClass, VisCam,
  VisView, ExtCtrls, StdCtrls, ComCtrls, Menus,visabout,
  VisPrimitiveObj, VisCanvasView, VisTimer, VisComp;

type
  TMainWnd = class(TForm)
    VisView1: TVisView;
    VisPerspectiveCamera1: TVisPerspectiveCamera;
    SphereAttribs: TVisAttributes;
    VisLight1: TVisLight;
    SphereMat: TVisMaterial;
    Panel1: TPanel;
    ColorDlg: TColorDialog;
    LblMaterial: TLabel;
    ShpMaterial: TShape;
    BtnMaterial: TButton;
    Label2: TLabel;
    Bevel2: TBevel;
    LblAlpha: TLabel;
    TrbAlpha: TTrackBar;
    VisSphere1: TVisSphere;
    MainMenu: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    N1: TMenuItem;
    About1: TMenuItem;
    CBTrans: TComboBox;
    Label3: TLabel;
    BackgroundTex: TVisTexture;
    VisTorus1: TVisTorus;
    TorusAttribs: TVisAttributes;
    VisTimer1: TVisTimer;
    procedure FormCreate(Sender: TObject);
    procedure VisView1Render(aView: TVisView);
    procedure BtnMaterialClick(Sender: TObject);
    procedure TrbAlphaChange(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure CBTransChange(Sender: TObject);
    procedure VisTimer1Timer(sender: TObject; lagcount: Integer);
  end;

var
  MainWnd: TMainWnd;

implementation

{$R *.DFM}

procedure TMainWnd.FormCreate(Sender: TObject);
begin
  ShpMaterial.Brush.Color := SphereMat.ColorDiffuse.Color;
end;

procedure TMainWnd.VisView1Render(aView: TVisView);
begin
  VisView1.Canvas.DrawTexture(rect(0,0,VisView1.Width,VisView1.Height),BackgroundTex,rect(0,0,BackgroundTex.Bitmap.Width,BackgroundTex.Bitmap.Height));
  VisLight1.Render(aView);
  VisTorus1.Render(aView);
  VisSphere1.Render(aView);
end;

procedure TMainWnd.BtnMaterialClick(Sender: TObject);
begin
  ColorDlg.Color := ShpMaterial.Brush.Color;
  if ColorDlg.Execute then begin
    ShpMaterial.Brush.Color := ColorDlg.Color;
    SphereMat.ColorDiffuse.Color := ColorDlg.Color;
    VisView1.InvalidateGL;
  end;
end;

procedure TMainWnd.TrbAlphaChange(Sender: TObject);
begin
  SphereMat.ColorDiffuse.Alpha := TrbAlpha.Position / 100;
  VisView1.InvalidateGL;
end;

procedure TMainWnd.About1Click(Sender: TObject);
begin
  showAboutDlg;
end;

procedure TMainWnd.Exit1Click(Sender: TObject);
begin
  close;
end;

procedure TMainWnd.CBTransChange(Sender: TObject);
begin
  SphereAttribs.Transparency := TVisTransparencyMode(CBTrans.ItemIndex);
  VisView1.InvalidateGL;
end;

procedure TMainWnd.VisTimer1Timer(sender: TObject; lagcount: Integer);
begin
  VisTorus1.Transformation.Rotation.incY(3);
  VisTorus1.Transformation.Rotation.incX(4);
  VisView1.InvalidateGL;
end;

end.
