unit Unit1;

//////////////////////////////////////////////////////////////
//Signsoft VisIt: FuncObj                                   //
//////////////////////////////////////////////////////////////
//This program demonstrates how to use the TVisFuncObj      //
//component. The three dimensional graph of the function    //
//z= x*x -y*y (hyperboloid) is displayed (slightly scaled). //
//Displaying other functions of the type f(x,y) will work   //
//the same way.                                             //
//////////////////////////////////////////////////////////////

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  VisTimer, visobj, visshape, VisCustomFuncObj, VisFuncObj, visclass,
  viscam, visview, vistex, visattr, Menus,visabout,vismath,
  VisPrimitiveObj, VisComp, VisCanvasView;

type
  TForm1 = class(TForm)
    View: TVisView;
    cam: TVisPerspectiveCamera;
    FuncObj: TVisFuncObj;
    Attr: TVisAttributes;
    Tex: TVisTexture;
    tim: TVisTimer;
    MainMenu: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    N1: TMenuItem;
    About1: TMenuItem;
    function FuncObjCalcXY(oldpoint: TVisMathVector;
      value: Double): TVisMathVector;
    function FuncObjCalcZ(oldpoint: TVisMathVector;
      value: Double): TVisMathVector;
    procedure ViewRender(aView: TVisView);
    procedure timTimer(sender: TObject; lagcount: Integer);
    procedure Exit1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

function TForm1.FuncObjCalcXY(oldpoint: TVisMathVector;
  value: Double): TVisMathVector;
begin
 //X-Value: use value passed with oldpoint (from CalcZ)
  result.X:=oldpoint.x;
 //Y-Value: use current value*2-1
  result.Y:=value*2-1;
 //Z-Value: calc height from x and y
  result.Z:=sqr(result.x)-sqr(result.y);
end;

function TForm1.FuncObjCalcZ(oldpoint: TVisMathVector;
  value: Double): TVisMathVector;
begin
 //this result is passed as oldpoint to CalcXY:
 result:=ToVec(value*2-1, 0, 0);
end;

procedure TForm1.ViewRender(aView: TVisView);
begin
  FuncObj.Render(aView);
end;

procedure TForm1.timTimer(sender: TObject; lagcount: Integer);
begin
   FuncObj.Transformation.Rotation.incX(3);
   FuncObj.Transformation.Rotation.incZ(3);
   View.InvalidateGL;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.About1Click(Sender: TObject);
begin
  ShowAboutDlg;
end;

end.
