unit MainWindow;

//////////////////////////////////////////////////////////////
//Signsoft VisIt: VisTube Tutorial                          //
//////////////////////////////////////////////////////////////
//This program illustrates the tutorial for the TVisTube    //
//component.                                                //
//////////////////////////////////////////////////////////////

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  VisLight, VisObj, VisAttr, VisClass, VisCam, VisView, VisShape,
  VisCustomFuncObj, VisTube, VisCntrl, VisTimer, Menus, VisAbout,
  VisPrimitiveObj, VisComp, VisCanvasView;

type
  TForm1 = class(TForm)
    VisView1: TVisView;
    VisPerspectiveCamera1: TVisPerspectiveCamera;
    VisAttributes1: TVisAttributes;
    VisLight1: TVisLight;
    VisNode1: TVisNode;
    VisTube1: TVisTube;
    VisTube2: TVisTube;
    VisTube3: TVisTube;
    VisTimer1: TVisTimer;
    MainMenu: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    N1: TMenuItem;
    About1: TMenuItem;
    VisMouseController1: TVisMouseController;
    procedure VisView1Render(aView: TVisView);
    procedure FormCreate(Sender: TObject);
    procedure VisTimer1Timer(sender: TObject; lagcount: Integer);
    procedure About1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.VisView1Render(aView: TVisView);
begin
 //rendering
 VisLight1.Render(aView);
 VisNode1.Render(aView);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin

{--jar--}

 //initial radius
 VisTube1.StartSegment.Radius:=0;
 //bottom
 VisTube1.AddLine(0,0,0, 0.2, 1);

 //side
 VisTube1.AddLine(0,0,0.36,0.350,10,rcEndSmooth);
 VisTube1.AddLine(0,0,0.25,0.190,10,rcSmooth);
 VisTube1.AddLine(0,0,0.10,0.225, 5,rcStartSmooth);
 //upper edge
 VisTube1.AddLine(0,0, 0.010,0.215,5,rcStartSmooth);
 VisTube1.AddLine(0,0,-0.005,0.210,5,rcEndSmooth);
 //lid
 VisTube1.AddLine(0,0,0.08, 0.03,10,rcStartSmooth);
 VisTube1.AddLine(0,0,0, 0.029,1);
 VisTube1.AddLine(0,0,0.02, 0.06,10,rcSmooth);
 VisTube1.AddLine(0,0,0.03, 0   ,10,rcStartSmooth);


{--handle--}

 //initial radius
 VisTube2.StartSegment.Radius:=0.04;
 //handle
 VisTube2.AddBend(-0.3,0, 0.20, 0.03);
 VisTube2.AddBend( 0  ,0,-0.25, 0.04);

 
{--spout--}

 //initial radius
 VisTube3.StartSegment.Radius:=0.13;
 //cant the initial plane
 VisTube3.StartSegment.VecX.X:=0;
 VisTube3.StartSegment.VecX.Z:=1;
 //bends
 VisTube3.AddBend(-0.10,0,0.10,0.07,10,rcSmooth);
 VisTube3.AddBend(-0.01,0,0.20,0.05,10,rcSmooth);
 VisTube3.AddBend(-0.03,0,0.09,0.04,3,rcSmooth);
 VisTube3.AddBend(-0.03,0,0.03,0.04,3,rcSmooth);
 //cant the ending
 VisTube3.Sections[VisTube3.SectionCount-1].EndAngleY:= -40;

 //use caching for faster calculation
 VisTube1.Cached:=true;
 VisTube2.Cached:=true;
 VisTube3.Cached:=true;
end;

procedure TForm1.VisTimer1Timer(sender: TObject; lagcount: Integer);
begin
//rotation
VisNode1.Transformation.Rotation.incZ(4);
VisView1.InvalidateGL;
end;

procedure TForm1.About1Click(Sender: TObject);
begin
 ShowAboutDlg;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
 Close;
end;

end.
